/***********************************/
// GLOBAL VALUE
/***********************************/
var gLastHeight;
var gLastWidth;
var gLastSRC;
var IMAGE_SRC_KEY = 'BlingImageSource';
var IMAGE_INDEX = 'BlingIMAGE_INDEX';
var DEFAULT_IMAGE_SOURCE = 'BlingTreasure/1.png';
var BLING_WEBSITE = 'http://www.xultrasoft.com/bling/';
/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.

function setup()
{
	if(window.widget)		// always check to make sure that you are running in Dashboard
	{
		// Retrieve the preferences
		var imageSource = widget.preferenceForKey(makeKey(IMAGE_SRC_KEY));
		var selIndex = widget.preferenceForKey(makeKey(IMAGE_INDEX));		
		if (imageSource == undefined || selIndex == undefined ) {
			imageSource = DEFAULT_IMAGE_SOURCE;
			selIndex = 0;
		}
		
		//init the widget
		var blingImage = document.getElementById("BlingObject");
		var popup = document.getElementById("BlingList");
		popup.selectedIndex = selIndex;
		blingImage.src = imageSource;
		window.resizeTo(blingImage.width, blingImage.height);
		
		var url = 'http://www.xultrasoft.com/bling/1';	
		var xml_request = new XMLHttpRequest();
		xml_request.overrideMimeType("text/xml");
		xml_request.open("GET", url);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
	}
}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	//store existing height/width, selection
	var blingImage = document.getElementById("BlingObject");
	gLastHeight = blingImage.height;
	gLastWidth = blingImage.width;
	gLastSRC = blingImage.src;
	
	//resize the window
	window.resizeTo(272, 384);

	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	playSound();
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	var blingImage = document.getElementById("BlingObject");
	var popup = document.getElementById("BlingList");
	var selInt = popup.selectedIndex;
	blingImage.src="BlingTreasure/" + selInt + ".png"
	
	//set the preference
	widget.setPreferenceForKey(blingImage.src,makeKey(IMAGE_SRC_KEY));
	widget.setPreferenceForKey(selInt,makeKey(IMAGE_INDEX));
	
	//adjust the window
	adjustWindow();
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}

function playSound() {
	document.getElementById('SoundEffect').Play();
}

function adjustWindow() {
	var blingImage = document.getElementById("BlingObject");
	var height = blingImage.height;
	var width = blingImage.width;

	if (blingImage.src == gLastSRC) {
		height = gLastHeight;
		width = gLastWidth;
	}
	
	window.resizeTo(width, height);
}


// makeKey makes the widget multi-instance aware

function makeKey(key)
{
	return (widget.identifier + "-" + key);
}


function goToWebsite()
{
	if (window.widget)
	{
		widget.openURL(BLING_WEBSITE);
	}
}

function sendEmail()
{
	if (window.widget)
	{
		widget.openURL("mailto:feedback@xultrasoft.com?subject=Bling: ");
	}
}

/***************/
// WIDGET EVENTS
/***************/

// removed is called when the widget is removed from the Dashboard

function removed()
{

	
}

// focused is called when the widget gets key focus

function focused()
{

}

// blurred is called when the widget looses key focus

function blurred()
{

}

// Here we register for some widget events

if(window.widget)
{
	widget.onremove = removed;
	window.onfocus = focused;
	window.onblur = blurred;
}	


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
/*	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	 
	animation.firstElement.style.opacity = animation.now;
	*/
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	//document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	//document.getElementById('fliprollie').style.display = 'none';
}